<template>
<body>
  <Toast position="top-left"/>
  <Menubar>
      <template #start class="p-col">
        <i class="pi pi-share-alt" style="color:#ba68c8;"></i> <!-- pi-globe or pi-share-alt -->
        Cosmos &#60;&#62; Ethereum Bridge
      </template>
      <template #end class="p-col">
        <WalletConnectButton/>
      </template>
  </Menubar>

  <div class="p-field container">
    <div id="swap-direction" class="p-grid p-nogutter">
      <!-- add ripple effect -->
      <SwapDirection class="p-col"/>
    </div>
    <div id="token-and-amount">
      <div class="p-grid p-nogutter">
      <div class="p-col">Amount</div>
      <div class="p-col">Selected Token</div>
      </div>
      <div class="p-grid p-nogutter">
        <div class="p-col">
          <InputNumber v-model="this.$store.state.amountToSend" :minFractionDigits="2" 
            :maxFractionDigits="18" :min="0" :placeholder="amount"
            mode="currency" v-bind:currency="selectedToken" showButtons />
        </div>
        <div class="p-col">
          <ToggleButton v-model="fromCosmosToEth" v-on:click="changeSwapDirection()" 
            onLabel="COS" offLabel="ETH" style="width: 22%;" />
        </div>
      </div>
    </div>

    <!-- <div id="sending-address">
      <div class="p-grid p-nogutter">
        <label>Sending address</label>
        <InputText id="to-address" class="p-inputtext-sm" type="text" disabled/>
      </div>
    </div> -->
    <div id="destination-address">
      <div class="p-grid p-nogutter">
        <span class="p-col p-float-label">
          <InputText v-if="isAddressValid" id="to-address" class="p-inputtext-sm" type="text" 
            v-model="this.$store.state.receivingAddress" v-on:change="changeReceivingAddress()"
            autocomplete="off"/>
          <InputText v-if="!isAddressValid" id="to-address" class="p-inputtext-sm p-invalid" type="text" 
            v-model="this.$store.state.receivingAddress" v-on:change="changeReceivingAddress()"
            autocomplete="off"/>
          <label for="to-address">Please enter the receiving address</label>
          <small v-if="!isAddressValid" id="username2-help" class="p-error">The address is invalid.</small>
        </span>
      </div>
    </div>
    <div id="transfer-summary">
      <div class="p-grid p-nogutter">
        <div class="p-col"><strong>Transfer summary</strong></div>
      </div>
      <br/>
      <div class="p-grid p-nogutter">
        <div class="p-col">Send From</div>
        <div v-if="fromCosmosToEth && isKeplrWalletConnected" class="p-col-8" style="text-align: right;">
          {{cosmosSendingAddress}}
        </div>
        <div v-if="!fromCosmosToEth && isMetamaskWalletConnected" class="p-col-8" style="text-align: right;">
          {{ethSendingAddress}}
        </div>
      </div>
      <div class="p-grid p-nogutter">
        <div class="p-col-10"/>
        <div class="p-col" style="text-align: right;">{{this.amountToSend}} {{selectedToken}}</div>
      </div>
      <br/>
      <div class="p-grid p-nogutter">
        <div class="p-col">To</div>
        <div v-if="isAddressValid" class="p-col-8" style="text-align: right;">
          {{receivingAddress}}</div>
      </div>
      <div class="p-grid p-nogutter">
        <div class="p-col-9"/>
        <div v-if="fromCosmosToEth" class="p-col" style="text-align: right;">
          {{this.amountToSend}} w{{selectedToken}}
        </div>
        <div v-if="!fromCosmosToEth" class="p-col" style="text-align: right;">
          {{this.amountToSend}} c{{selectedToken}}
        </div>
      </div>
    </div>
    

    <SendTokensButton/>
  </div>
</body>
</template>

<script>
import SwapDirection from './components/swap-direction/SwapDirection.vue'
import WalletConnectButton from './components/WalletConnectButton.vue'
import SendTokensButton from './components/SendTokensButton.vue'

const ethRegex = /^0x[a-fA-F0-9]{40}$/;
const cosmosRegex = /^cosmos/

export default{
  name: 'App',
  components:{
    SwapDirection,
    WalletConnectButton,
    SendTokensButton
  },
  data(){
    return {
		selectedToken: "COS",
    amount: 0,
    web3: null,
    timer: ''
    }
  },
  created(){
    this.timer = setInterval(this.checkWalletConnections, 3000);
  },
  computed:{
    fromCosmosToEth(){
      return this.$store.state.fromCosmosToEth
    },
    receivingAddress(){
      return this.$store.state.receivingAddress
    },
    isMetamaskWalletConnected(){
      return this.$store.state.isMetamaskWalletConnected
    },
    isKeplrWalletConnected(){
      return this.$store.state.isKeplrWalletConnected
    },
    amountToSend(){
      return this.$store.state.amountToSend
    },
    isAddressValid(){
      return this.$store.state.isAddressValid
    },
    cosmosSendingAddress(){
      return this.$store.state.cosmosSendingAddress
    },
    ethSendingAddress(){
      return this.$store.state.ethSendingAddress
    }
  },
  methods: {
    changeSwapDirection(){
      //when we click we change the value of the fromCosmosToEth boolean
      this.$store.commit('changeSwapDirection');
      //swap direction changed so user have to change the wallet used
      // this.$store.commit('setIsWalletConnected',false);
      //reset receiving address to null
      this.$store.commit('setReceivingAddress',null);
      
      //then we display correct elements according to swap direction choosed by user
      if(this.fromCosmosToEth == true) {
        this.selectedToken = "COS";        
        this.$toast.add({severity:'info', summary: 'Swap direction changed', detail:'Cosmos -> Ethereum', life: 2000});
      }
      else {
        this.selectedToken = "ETH";
        this.$toast.add({severity:'info', summary: 'Swap direction changed', detail:'Ethereum -> Cosmos', life: 2000});
      }
    },
    changeReceivingAddress(){
      //case 1: COSMOS -> ETH
      if(this.fromCosmosToEth){
        this.$store.commit('setIsAddressValid',ethRegex.test(this.receivingAddress))
      }
      //case 2: ETH -> COSMOS
      else{        
        this.$store.commit('setIsAddressValid',cosmosRegex.test(this.receivingAddress))
      }  
    },
    checkWalletConnections(){
      console.log("...")
      //monitor metamask disconnection && accounts switch
      window.ethereum.on('accountsChanged', () => {
        console.log('> metamask disconnected')
        this.$store.commit('setIsMetamaskWalletConnected',false)
      });

      //PROBLEM: only works when the user switch account
      //not working when the user disconnect wallet
      window.addEventListener("keplr_keystorechange", () => {
        console.log('> keplr disconnected')
        this.$store.commit('setIsKeplrWalletConnected',false)
      })
    },
    cancelAutoUpdate () {
        clearInterval(this.timer);
    }
  },
  beforeUnmount(){
    this.cancelAutoUpdate();
  }
}

</script>

<style lang="scss">

  html, body {
    width: 100%;
    height: 100%;
    margin: 0;
    padding: 0;
    box-sizing: border-box;
    color: white;
    font-family: sans-serif;
    background-color: rgba(23,33,47);
  }

  .container {
    width: 61%;
    margin: 0 auto;
    padding: 265px;
    background: rgba(31,45,64);
    align-content: space-between;
    position: relative;
  }

  #token-and-amount{
    position: absolute;
    top: 130px;
    left: 10%;
    right: 10%;
  }  

  // #sending-address{
  //   position: absolute;
  //   top: 230px !important;
  //   left: 10%;
  //   right: 10%;
  // }

  #destination-address{
    position: absolute;
    top: 220px;
    left: 10%;
    right: 10%;
  }

  #transfer-summary{
    background: rgba(23,33,47);
    position: absolute;
    top: 290px;
    left: 10%;
    right: 10%;
    border: 1px solid #304562;
    padding: 10px;
    // background: #1f2d40;
    color: rgba(255, 255, 255, 0.87);
    border-radius: 3px;
  }

  #to-address{
    width: 100%;
  }


  //test classes to visualize the containers
  .blue{
    background:blue;
  }
  .green{
    background:green;
  }
  .red{
    background:red;
  }
  .yellow{
    background:yellow;
  }
  .orange{
    background:orange;
  }
  .purple{
    background:purple;
  }

</style>